********************************************************************
*
*                   HOT_DODO
*
*                   . W. LENERZ
*
*                   1991 Jun 30 14:55:18
*
*********************************************************************


vers equ '1.07'

; HEADER FOR JOBS

debut     BRA.S     start
          DC.L      'W.L.'
          DC.W      $4AFB
jblen     DC.W      8
          DC.W      'HOT_DODO'
hkname    DS.B      34

start     ADD.L     A6,A4               ; point to start of data area
          LEA       2(A7),A6
          MOVEQ     #-1,D7              ; FLAG: we have not yet used the thing
          MOVEQ     #0,D0
          TRAP      #1                  ; obtient var. sys.
          ADD.L     #$B8,A0             ; pointeur sur liste des THINGs
bflp1     MOVE.L    (A0),D1             ; pointeur suivant
          BEQ.S     th_found            ; si 0, c'est LA THING
          MOVE.L    D1,A0
          BRA.S     bflp1
th_found  MOVE.L    $10(A0),A0
          CMP.L     #'THG%',(A0)
          BNE       harakiri
          CMP.L     #-1,4(A0)           ; OK?
          BNE.S     harakiri            ; non, alors on n'utilise pas
          MOVE.L    8(A0),A5            ; A5= THING VECTOR
          CLR.L     D0
          MOVE.W    #$1,(A4)+
          MOVE.W    #$0,(A4)
          LEA       hkn,A0
          MOVEQ     #$28,D0
          MOVEQ     #-1,D1
          MOVEQ     #-1,D3
          JSR       (A5)                ; use hotkey thing
          TST.W     D0
          BNE.S     harakiri
          MOVE.L    A1,A3               ; A3 points to thing linkage block
          TST.W     (A6)
          BEQ.S     no_cmdstr
          MOVE.L    A6,A0
          BRA.S     common
no_cmdstr LEA       key,A0
common    MOVE.W    (A0)+,D7            ; number of hotkeys to DO
          BEQ.S     thfree              ; if none, leave
          SUBQ.W    #1,D7               ; prepare for DBF
round     MOVE.B    (A0)+,(A4)          ; put in this hotkey
          LEA       -2(A4),A1           ; A1 points to it
          MOVE.L    $14(A3),A2
          JSR       (A2)                ; find this item, A1 will contain
                                        ; pointer to it
          TST.W     D0                  ; does it exist?
          BNE.S     gogo                ; no, so gogo around
          MOVE.L    $28(A3),A2
          JSR       (A2)                ; DO the key
          MOVEM.L   A0/A1,-(A7)         ; suspend
          LEA       delai,A1
          CLR.L     D3
          MOVE.B    (A1),D3
          BEQ.S     no_wait
          MULU      #5,D3               ; 1/10th of a second
          SUB.L     A1,A1
          MOVEQ     #-1,D1
          MOVEQ     #8,D0
          TRAP      #1
no_wait   MOVEM.L   (A7)+,A0/A1

gogo      DBF       D7,round
thfree    MOVEQ     #$29,D0
          LEA       hkn,A0
          MOVEQ     #-1,D1
          MOVEQ     #-1,D3
          JSR       (A5)                ; free thing
harakiri  MOVEQ     #5,D0
          MOVEQ     #-1,D1
          TRAP      #1                  ; japanese good-bye

; POST: post processing routines for configurable item

post      TST.B     D1
          BEQ.S     outpost
          LEA       key,A0
          LEA       jblen,A3
          MOVE.W    #'  ',10(A3)
          MOVE.W    (A0)+,D0
          BEQ.S     outpost
          ADD.L     #10,D0
          MOVE.W    D0,(A3)
          LEA       hkname,A3
          MOVE.W    #': ',(A3)+
          SUB.L     #11,D0
loop1     MOVE.B    (A0)+,(A3)+
          DBF       D0,loop1
outpost   CLR.L     D0
          RTS

hkn       DC.W      6,'HOTKEY'
config    DC.L      '<<QCFX>>'
          DC.W      '01'
          DC.W      8,'HOT_DODO'
          DC.W      4
          DC.L      vers                ; version
          DC.B      0,'T'               ; type and selkey
          DC.W      key2-*              ; pointer to item
          DC.W      0                   ; no preprocessing
          DC.W      post-*              ; post processing
          DC.W      descr-*             ; description
          DC.W      attr-*              ; attributes (0)
          DC.B      8,'D'
          DC.W      delai-*
          DC.L      0
          DC.W      del_desc-*
          DC.W      del_attr-*

          dc.w      -1

attr      DC.W      0
descr     DC.W      descr2-*-2
          DC.B      'Please the keys serving as hotkeys, to be executed',$a
descr2
key2      DC.W      30                  ; maxlen
key       DC.W      0
          DS.B      36

delai     DC.B      1,0
del_desc  DC.W      ddesc2-*-2
          DC.b      'Pause between each Hotkey, in 1/10th of a second (0 t0 200)'
ddesc2
          dc.w      0
del_attr  DC.B      0,200

          END
